
package org.remote.roadhog;

import java.util.*;
import java.io.*;

import org.w3c.dom.*;

class ShowcaseItem extends XMLObject
{
	private HashMap text = new HashMap ();
	public Vector illustrations = null;
	private String from = null, to = null, alternative = null;
	
	public ShowcaseItem ()
	{
		/* default */
	}

	public ShowcaseItem (Node node)
	throws ParseException
	{
		NodeList sublist;
		Element item = (Element) node;
		int length;

		parseAttributeWithLanguage (item, "text", text);

		sublist = item.getElementsByTagName ("illustration");
		length = sublist.getLength ();
		for (int i=0; i<length; i++)
		{
			if (illustrations == null) illustrations = new Vector ();
			illustrations.addElement (new Illustration (sublist.item (i)));
		}
		sublist = item.getElementsByTagName ("from");
		if (sublist.getLength () == 1) from = getTextChild (sublist.item(0));
		sublist = item.getElementsByTagName ("to");
		if (sublist.getLength () == 1) to = getTextChild (sublist.item(0));
		sublist = item.getElementsByTagName ("alternative");
		if (sublist.getLength () == 1) alternative = getTextChild (sublist.item(0));

	}

	public void toXML (PrintStream o, String indent)
	{
		o.println (indent + "<showcase-item>");
		writeAttributeWithLanguage (o, indent + "   ", "text", text);
		if (illustrations != null)
		{
			for (Enumeration e = illustrations.elements (); e.hasMoreElements (); )
			{
				((Illustration)e.nextElement ()).toXML (o, indent + "   ");
			}
		}
		if (from != null) o.println (indent + "   <from>"+from+"</from>");
		if (to != null) o.println (indent + "   <to>"+to+"</to>");
		if (alternative != null) o.println (indent + "   <alternative>"+alternative+"</alternative>");
		o.println (indent + "</showcase-item>");
	}

	public boolean journeyMatches (Journey j)
	{
		return (j.from.id.equals (from) && j.to.id.equals (to) &&
			((j.getAlternative () == null) || (j.getAlternative ().equals (alternative))));
	}

	public String getText (String lang)
	{
		return (getAttributeInLanguage (text, lang));
	}
}
